"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseI18N = exports.parse = void 0;
/**
 * Parse file to Model Module
 * @file
 */
var locale_1 = require("./locale");
var parse_1 = require("./parse");
var pipeable_1 = require("fp-ts/pipeable");
var E = require("fp-ts/Either");
/**
 * parse file to locale module
 * @desczh
 * 解析ts文件到`Module`
 */
var parse = function (locale) { return function (files) {
    var data = (0, parse_1.default)(files);
    return (0, pipeable_1.pipe)(data, E.map(function (as) {
        return as.map(function (a) { return (0, locale_1.default)(locale)(a); });
    }));
}; };
exports.parse = parse;
/**
 * parse file to locale module
 * @desczh
 * 解析ts文件到`Module`(i18n)
 */
var parseI18N = function (locale) { return function (files) {
    var data = (0, exports.parse)(locale)(files);
    return (0, pipeable_1.pipe)(data, E.map(function (as) { return as; }), E.mapLeft(function (as) { return as; }));
}; };
exports.parseI18N = parseI18N;
//# sourceMappingURL=index.js.map