"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tagToRecord = exports.getTag = exports.hasTag = exports.parseJSDoc = void 0;
var doctrine_1 = require("doctrine");
var macoolka_compare_1 = require("macoolka-compare");
var monocle_ts_1 = require("monocle-ts");
var A = require("fp-ts/Array");
var function_1 = require("fp-ts/function");
var pipeable_1 = require("fp-ts/pipeable");
var macoolka_collection_1 = require("macoolka-collection");
var lensTitle = monocle_ts_1.Lens.fromProp()('title');
var parseJSDoc = function (source) {
    return (0, doctrine_1.parse)(source, { unwrap: true });
};
exports.parseJSDoc = parseJSDoc;
var hasTag = function (tag) { return function (annotation) {
    return (0, macoolka_compare_1.arrayCompare)().contains_every(annotation.tags.map(lensTitle.get))(tag);
}; };
exports.hasTag = hasTag;
var getTag = function (tag) { return function (annotation) {
    return (0, pipeable_1.pipe)(annotation.tags, A.findFirst((0, function_1.flow)(lensTitle.get, macoolka_compare_1.compareString.eq(tag))));
}; };
exports.getTag = getTag;
var tagToRecord = function (a) {
    return (0, pipeable_1.pipe)(a.tags, macoolka_collection_1.array.toRecord('title'));
};
exports.tagToRecord = tagToRecord;
//# sourceMappingURL=jsdoc.js.map