"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.localeModule = exports.localeInterface = void 0;
/**
 * Locale a Module
 * @desczh
 * 对一个模块进行本地化
 * @file
 */
var O = require("fp-ts/Option");
var pipeable_1 = require("fp-ts/pipeable");
var macoolka_object_1 = require("macoolka-object");
var macoolka_collection_1 = require("macoolka-collection");
//import { getGlobalI18N } from 'macoolka-env'
var getLocaleDocumentable = function (locale) { return function (a) {
    return (__assign(__assign({}, (0, macoolka_object_1.omit)(a, ['descriptions'])), { description: locale
            ? (0, pipeable_1.pipe)((0, macoolka_object_1.get)(a.descriptions, locale), O.fromNullable, O.getOrElse(function () { return a.description; }))
            : a.description }));
}; };
function printInterfaceItem(a) {
    var content = '\n  ' + a.signature ? a.signature : '';
    if (a.description.length > 0) {
        var desc = '  /**\n';
        desc += a.description.map(function (a) { return "   *".concat(a); }).join('\n');
        desc += '\n   */\n';
        return desc + content;
    }
    return content;
}
function buildInterface(a) {
    var content = "\ninterface ".concat(a.name, " ").concat(a.implements.length > 0
        ? "extends ".concat(a.implements.join(','))
        : '', "{\n");
    content += a.fields.map(printInterfaceItem).join('\n');
    content += a.methods.map(printInterfaceItem).join('\n');
    content += '\n}\n';
    return content;
}
var localeInterface = function (locale) {
    return function (a) {
        var _result = __assign(__assign({}, getLocaleDocumentable(locale)(a)), { fields: (0, pipeable_1.pipe)(a.fields, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })), methods: (0, pipeable_1.pipe)(a.methods, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })) });
        var result = __assign(__assign({}, _result), { signature: buildInterface(getLocaleDocumentable(locale)(_result)) });
        return result;
    };
};
exports.localeInterface = localeInterface;
var localeTypeAlias = function (locale) {
    return function (a) {
        var result = __assign(__assign({}, getLocaleDocumentable(locale)(a)), { fields: (0, pipeable_1.pipe)(a.fields, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })), methods: (0, pipeable_1.pipe)(a.methods, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })) });
        return result;
    };
};
var localeClass = function (locale) { return function (a) {
    var result = __assign(__assign({}, getLocaleDocumentable(locale)(a)), { fields: (0, pipeable_1.pipe)(a.fields, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })), methods: (0, pipeable_1.pipe)(a.methods, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })), staticMethods: (0, pipeable_1.pipe)(a.staticMethods, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })) });
    return result;
}; };
/**
 * Locale a Module.
 * Replace desc'locale' to description
 * @desczh
 * 本地化一个模块
 * 用desc'locale'替换description
 * @since 0.2.0
 */
var localeModule = function (locale) { return function (a) {
    var result = __assign(__assign({}, getLocaleDocumentable(locale)(a)), { constants: (0, pipeable_1.pipe)(a.constants, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })), functions: (0, pipeable_1.pipe)(a.functions, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })), classes: (0, pipeable_1.pipe)(a.classes, macoolka_collection_1.array.map(function (value) { return localeClass(locale)(value); })), interfaces: (0, pipeable_1.pipe)(a.interfaces, macoolka_collection_1.array.map(function (value) { return (0, exports.localeInterface)(locale)(value); })), typealiases: (0, pipeable_1.pipe)(a.typealiases, macoolka_collection_1.array.map(function (value) { return localeTypeAlias(locale)(value); })), exports: (0, pipeable_1.pipe)(a.exports, macoolka_collection_1.array.map(function (value) { return getLocaleDocumentable(locale)(value); })) });
    return result;
}; };
exports.localeModule = localeModule;
exports.default = exports.localeModule;
//# sourceMappingURL=locale.js.map